/*

Released by NZMac.com (http://www.nzmac.com)
under the Creative Commons Attribution-NonCommercial 2.0 license
http://creativecommons.org/licenses/by-nc/2.0/

You are free:
* to copy, distribute, display, and perform the work
* to make derivative works

Under the following conditions:
* Attribution. You must give the original authors credit.
* Non-commercial. You may not use this work for commercial purposes.

For any reuse or distribution, you must make clear to others the license
terms of this work.

Any of these conditions can be waived if you get permission from the
copyright holder.

Your fair use and other rights are in no way affected by the above.

Philip Roy - Initial code - http://www.bluengrey.com
Craig Stanton - Advanced Programming - http://craig.stanton.net.nz/
Cian Walsh - Widget graphics - http://www.afterglow.ie/

----------

* Portions Copyright  2005, Apple Computer, Inc.  All rights reserved.
* Inspiration from Julius Vu (JaRSS widget) and Wishingline.com (Xcode
template)
* Script to parse RSS XML data files written by Mark Wilton-Jones
  Script to import XML data files and make them available to JavaScript
written by Mark Wilton-Jones
  http://www.howtocreate.co.uk/jslibs/termsOfUse.html for terms of use

*/




// JavaScript Document
var month_names = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

var feedKey = 'savedFeedURL';
var timeKey = 'savedRefreshTime';



/* Apple Javascript from Dashboard Tutorial Document   */

if (window.widget) {
    widget.onshow = onshow;
}

function onshow() {
    back.style.display="none"; 
    front.style.display="block";
}

function setUpdatedText(){
	updateArea = document.getElementById('lastUpdate');
	
	updateDisplayText = 'Feed last checked - ';
	var dd=new Date;
	var dayOfMonth = dd.getDate();
	var dateType = "";
	if (dayOfMonth == 1 || dayOfMonth == 21 || dayOfMonth ==31)
	   {
	   dateType = "st";
	   }
	else if (dayOfMonth == 2 || dayOfMonth == 22)
	   {
	   dateType = "nd";
	   }
	else if (dayOfMonth == 3 || dayOfMonth == 23)
	   {
	   dateType = "rd";
	   }
	else
	   {
	   dateType = "th";
	   }
	
	var hours = dd.getHours();
	var ampm = 'am';
	if (hours >= 12) {
		ampm = 'pm';
	}
		
	if (hours > 12) {
		hours -= 12;
	}

	var minutes = dd.getMinutes();
	if (minutes < 10){
		minutes = '0' + minutes;
	}

	updateDisplayText += dayOfMonth+dateType + ' ' + month_names[dd.getMonth()] + ' ' + dd.getFullYear() + ' ' + hours + ':' + minutes + ' ' + ampm;


	updateArea.innerHTML = updateDisplayText;
	
}

function saveFeedPref(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName.feedURL.value, feedKey);
	}
}

function saveTimePref(){
	if (window.widget){
		widget.setPreferenceForKey(document.formName.interv.value, timeKey);
	}
}

function restoreSavedPrefs(){
	updateArea = document.getElementById('lastUpdate');
	if (window.widget){
		savedFeedValue = widget.preferenceForKey(feedKey);
		savedTimeValue = widget.preferenceForKey(timeKey);

		if (savedFeedValue != ''){
			for( i = 0; i < document.formName.feedURL.length; i++){
				if (document.formName.feedURL.options[i].value == savedFeedValue){
					document.formName.feedURL.options[i].selected = true;
				}
			}
		}

		if (savedTimeValue != ''){
			for( i = 0; i < document.formName.interv.length; i++){
				if (document.formName.interv.options[i].value == savedTimeValue){
					document.formName.interv.options[i].selected = true;
				} 
			}
		}

	}
}

function Go(){
	theForm = document.formName;
	if(window.myInterval){
		window.clearInterval(window.myInterval);
	}
	if(importXML(theForm.feedURL.value,'parseRSS',false,2000)){
		if(parseFloat(theForm.interv.value)){
			window.myInterval=window.setInterval('importXML(theForm.feedURL.value,\'parseRSS\',false,2000);',parseFloat(theForm.interv.value)*60000);
		}
	}
	else{
		alert('Your browser cannot import XML, so it cannot view RSS feeds using this script');
	}
	
}
function showPrefs() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);  
} 

function hidePrefs() 
{ 
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    back.style.display="none"; 
    front.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0); 
	Go();
} 

/* Hiding and showing the info button   */
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

/********************************************************************************************************
                                    Script to parse RSS XML data files
                                        Written by Mark Wilton-Jones

Please see http://www.howtocreate.co.uk/jslibs/ for details and a demo of this script
Please see http://www.howtocreate.co.uk/tutorials/jsexamples/importingXML.html for a demo and description
Please see http://www.howtocreate.co.uk/jslibs/termsOfUse.html for terms of use
********************************************************************************************************/

function clicked (section)
    {
        if (widget)
        {
            widget.openURL(section);
        }
    }

function parseRSS(oDocObj) {

	//check if the browser interpreted the XML correctly
	if( oDocObj.documentElement && oDocObj.documentElement.tagName && oDocObj.documentElement.tagName.toUpperCase() == 'HTML' ) {
		setTimeout('alert(\'For no apparent reason, your browser has turned the RSS feed into HTML based garbage.\\nScript aborted.\');',50); return; }
	var chanEl = oDocObj.getElementsByTagName('channel')[0];
	if( !chanEl ) { alert('Format was not recognised as a valid RSS feed'); return; }
	var RSSversion = oDocObj.getElementsByTagName('rssSpoof')[0] ? oDocObj.getElementsByTagName('rssSpoof')[0].getAttribute('version') : '';


	//get the information about the feed
	for( var x = 0, y, feedInfo = []; y = chanEl.childNodes[x]; x++ ) {
		if( y.tagName && y.tagName != 'item' ) {
			if( y.tagName == 'image' ) {
				feedInfo['image'] = [];
				for( var i = 0, j; j = y.childNodes[i]; i++ ) {
					if( j.tagName ) {
						feedInfo['image'][j.tagName] = j.firstChild ? j.firstChild.nodeValue : '';
						if( RSSversion.match(/0?.91/) ) { feedInfo['image'][j.tagName] = feedInfo['image'][j.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }
					}
				}
			} else {
				feedInfo[y.tagName] = y.firstChild ? y.firstChild.nodeValue : '';
				if( RSSversion.match(/0?.91/) ) { feedInfo[y.tagName] = feedInfo[y.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }
			}
		}
	}

	if( !feedInfo['lastBuildDate'] ) { feedInfo['lastBuildDate'] = feedInfo['pubDate']; }

	//parse each news item
	for( var x = 0, y = oDocObj.getElementsByTagName('item'), newsItems = []; y[x]; x++ ) {
		newsItems[x] = [];
		for( var i = 0, j; j = y[x].childNodes[i]; i++ ) {
			if( j.tagName ) {
				newsItems[x][j.tagName] = j.firstChild ? j.firstChild.nodeValue : '';
				if( RSSversion.match(/0?.91/) ) { newsItems[x][j.tagName] = newsItems[x][j.tagName].replace(/&/g,'&amp;').replace(/"/g,'&quot;').replace(/</g,'&lt;').replace(/>/g,'&gt;'); }
			}
		}
	}

	//now that the entire feed has been converted into JavaScript arrays, it is time to write it out
	//document.title = feedInfo['title'] ? ( 'RSS feed: ' + feedInfo['title'] ) : 'Untitled newsfeed';

	//headers
	var oFeedStr = '<div class="rssarea"><div class="headers">'+
		((feedInfo['image']&&feedInfo['image']['url'])?(
			(feedInfo['image']['link']?('<div class="withImage"><a href="#" onClick="clicked(\''+feedInfo['image']['link']+'\');">'):'')+
			'<img src="'+feedInfo['image']['url']+'" alt="'+(feedInfo['image']['title']?feedInfo['image']['title']:'')+'">'+
			(feedInfo['image']['link']?'<\/a></div>':'')
		):'')+
		//'<h2>'+(feedInfo['link']?('<a href="'+feedInfo['link']+'">'+document.title+'<\/a>'):document.title)+'<\/h2>'+
		//(feedInfo['description']?('<p><b>Description:<\/b> '+feedInfo['description']+'<\/p>'):'')+
		//(feedInfo['lastBuildDate']?('<p><b>Published date:<\/b> '+feedInfo['lastBuildDate']+'<\/p>'):'')+
		'<\/div><div class="newsitems">\n';

	for( var x = 0, y; y = newsItems[x]; x++ ) {
		oFeedStr += '<div class="feeditem"><h3><a href="#" onClick="clicked(\''+newsItems[x]['link']+'\');">'+(newsItems[x]['title']?newsItems[x]['title']:'Untitled')+'<\/a><\/h3>'+'<\/div>\n';
	}

	//footer
	oFeedStr += '</div>'+
		//(feedInfo['copyright']?('<div class="footers"><p><b>Copyright:<\/b> '+feedInfo['copyright']+'<\/p><\/div>'):'')+
		'</div>\n';

	//output
	document.getElementById('feedcontainer').innerHTML = oFeedStr;
	
	setUpdatedText();
}